# ``twisted`.`conch`.`endpoints`.`_NewConnectionHelper``

class documentation

`class _NewConnectionHelper: (source)`

Implements interfaces: `twisted.conch.endpoints._ISSHConnectionCreator`

View In Hierarchy

`_NewConnectionHelper` implements `_ISSHConnectionCreator` by establishing a brand new SSH connection, securing it, and authenticating.

Method | `__init__` |
Method | `cleanupConnection` | Clean up the connection by closing it. The command running on the endpoint has ended so the connection is no longer needed.
Method | `secureConnection` | Create and return a new SSH connection which has been secured and on which authentication has already happened.
Instance Variable | `agentEndpoint` | Undocumented
Instance Variable | `command` | Undocumented
Instance Variable | `hostname` | Undocumented
Instance Variable | `keys` | Undocumented
Instance Variable | `knownHosts` | Undocumented
Instance Variable | `password` | Undocumented
Instance Variable | `port` | Undocumented
Instance Variable | `reactor` | Undocumented
Instance Variable | `tty` | Undocumented
Instance Variable | `ui` | Undocumented
Instance Variable | `username` | Undocumented
Class Method | `_knownHosts` |
Method | `_opener` | Open the tty if possible, otherwise give back a file-like object from which `b"no"` can be read.

def __init__(self, reactor, hostname, port, command, username, keys, password, agentEndpoint, knownHosts, ui, tty=FilePath(b'/dev/tty')): (source)

Parameters
reactor | Undocumented
hostname | Undocumented
port | Undocumented
command | Undocumented
username | Undocumented
keys | Undocumented
password | Undocumented
agentEndpoint | Undocumented
knownHosts | Undocumented
ui | Undocumented
tty:`FilePath` | The path of the tty device to use in case `ui` is `None`.
See Also
`SSHCommandClientEndpoint.newConnection`

def cleanupConnection(self, connection, immediate): (source)
from `twisted.conch.endpoints._ISSHConnectionCreator`
Clean up the connection by closing it. The command running on the endpoint has ended so the connection is no longer needed.

Parameters
connection:`SSHConnection` | The `SSHConnection` to close.
immediate:`bool`. | Whether to close connection immediately.

def secureConnection(self): (source)
from `twisted.conch.endpoints._ISSHConnectionCreator`
Create and return a new SSH connection which has been secured and on which authentication has already happened.

Returns
A `Deferred` which fires with the ready-to-use connection or with a failure if something prevents the connection from being setup, secured, or authenticated.

agentEndpoint = (source)

Undocumented

command = (source)

Undocumented

hostname = (source)

Undocumented

keys = (source)

Undocumented

knownHosts = (source)

Undocumented

password = (source)

Undocumented

port = (source)

Undocumented

reactor = (source)

Undocumented

tty = (source)

Undocumented

ui = (source)

Undocumented

username = (source)

Undocumented

@classmethod
def _knownHosts(cls): (source)

Returns
`KnownHostsFile` | A `KnownHostsFile` instance pointed at the user's personal known hosts file.

def _opener(self): (source)

Open the tty if possible, otherwise give back a file-like object from which `b"no"` can be read.

For use as the opener argument to `ConsoleUI`.